<?php
/**
 * Page Cache Ultimate, Page Cache standard and Speed pack are powered by Jpresta (jpresta . com)
 *
 * @author    Jpresta
 * @copyright Jpresta
 * @license   See the license of this module in file LICENSE.txt, thank you.
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

use AdvancedSearch\Models\Seo;

/**
 * Implements getJprestaModelObjectClassName() and getJprestaModelObjectId() to enable the HTML cache provided by the
 * module Page Cache Ultimate created by jpresta.com
 */
class pm_advancedsearch4seoModuleFrontControllerOverride extends pm_advancedsearch4seoModuleFrontController
{
    /**
     * @return string The ObjectModel class name to be used by Page Cache Ultimate module to refresh the cache of pages generated by this controller
     */
    public static function getJprestaModelObjectClassName()
    {
        return 'AdvancedSearch\Models\Seo';
    }

    /**
     * @return int|null The ID of the current ObjectModel (if any) to be used by Page Cache Ultimate module to refresh the cache of pages generated by this controller
     */
    public function getJprestaModelObjectId()
    {
        $id_seo = (int)Tools::getValue('id_seo');
        if ($id_seo && ($seoObj = new Seo($id_seo)) && Validate::isLoadedObject($seoObj)) {
            return $id_seo;
        }
        return null;
    }
}
